/*
 * generated by Xtext
 */
package com.framsticks.framclipse.formatting;

import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;

import com.framsticks.framclipse.services.FramScriptGrammarAccess;
import com.framsticks.framclipse.services.FramScriptGrammarAccess.ArrayElementExpressionElements;
import com.framsticks.framclipse.services.FramScriptGrammarAccess.BlockElements;
import com.framsticks.framclipse.services.FramScriptGrammarAccess.ForStatementElements;
import com.framsticks.framclipse.services.FramScriptGrammarAccess.FunctionElements;
import com.framsticks.framclipse.services.FramScriptGrammarAccess.IfStatementElements;
import com.framsticks.framclipse.services.FramScriptGrammarAccess.WhileStatementElements;

/**
 * This class contains custom formatting declarations.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#formatting
 * on how and when to use it.
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
public class FramScriptFormatter extends AbstractDeclarativeFormatter {
	@Override
	protected void configureFormatting(FormattingConfig c) {
		FramScriptGrammarAccess f = (FramScriptGrammarAccess) getGrammarAccess();
		
		//Headers
		c.setLinewrap().after(f.getNeuroAccess().getClassKeyword_0());
		
		c.setLinewrap().after(f.getExpdefAccess().getExpdefKeyword_0());
		
		c.setLinewrap().before(f.getPropertyAccess().getPropKeyword_0());
		c.setLinewrap().after(f.getPropertyAccess().getPropKeyword_0());
		c.setLinewrap().after(f.getPropertyAccess().getNameAssignment_3());
		c.setNoSpace().before(f.getPropertyAccess().getNameAssignment_3());
		
		c.setLinewrap().before(f.getStateAccess().getStateKeyword_0());
		c.setLinewrap().after(f.getStateAccess().getStateKeyword_0());
		c.setLinewrap().after(f.getStateAccess().getNameAssignment_3());
		c.setNoSpace().before(f.getStateAccess().getNameAssignment_3());
		
		c.setNoSpace().before(f.getHeaderAccess().getValueAssignment_1());
		
		c.setLinewrap().after(f.getNeuroHeaderAccess().getIntValueAssignment_0_2());
		c.setNoSpace().after(f.getNeuroHeaderAccess().getNameAssignment_0_1());
		
		c.setLinewrap().after(f.getNeuroHeaderAccess().getIconAssignment_1_2());
		c.setNoSpace().before(f.getNeuroHeaderAccess().getIconAssignment_2_2());
		
		c.setLinewrap().after(f.getNeuroHeaderAccess().getNameIconKeyword_2_1_0());
		c.setLinewrap().after(f.getNeuroHeaderAccess().getIconAssignment_2_2());
		c.setLinewrap().after(f.getNeuroHeaderAccess().getTildeKeyword_2_3());
		
		c.setNoSpace().around(f.getIconAccess().getCommaKeyword_1_0());
		
		c.setLinewrap().after(f.getFlagsHeaderAccess().getIntValueAssignment_2());
		c.setNoSpace().before(f.getFlagsHeaderAccess().getIntValueAssignment_2());
		
		c.setNoSpace().after(f.getTypeHeaderAccess().getNameTYPE_HEADERTerminalRuleCall_0_0());
		c.setLinewrap().after(f.getTypeHeaderAccess().getTypeAssignment_1());
		
		c.setLinewrap().after(f.getCodeSectionAccess().getCodeKeyword_0());
		c.setLinewrap().after(f.getCodeSectionAccess().getCodeParserRuleCall_1());
		c.setLinewrap(2).after(f.getCodeSectionAccess().getTildeKeyword_2());
		
		//Members
		c.setLinewrap(2).before(f.getFunctionAccess().getFunctionKeyword_0());
		c.setLinewrap(2).before(f.getGlobalAccess().getGlobalKeyword_0());

		// Line
		Keyword semicolon = f.getStatementAccess().getSemicolonKeyword_0_1();
		c.setLinewrap().after(semicolon);
		c.setNoSpace().before(semicolon);
		c.setNoLinewrap().before(semicolon);
		
		//Function
		FunctionElements function = f.getFunctionAccess();
		c.setNoSpace().around(function.getLeftParenthesisKeyword_3());
		c.setNoSpace().around(function.getRightParenthesisKeyword_5());
		c.setNoSpace().before(function.getCommaKeyword_2_0());
		c.setNoSpace().before(function.getCommaKeyword_4_1_0());

		// BlockIndentation
		BlockElements block = f.getBlockAccess();
		c.setIndentation(block.getLeftCurlyBracketKeyword_0(),
				block.getRightCurlyBracketKeyword_2());
		c.setLinewrap().before(block.getLeftCurlyBracketKeyword_0());
		c.setLinewrap().after(block.getLeftCurlyBracketKeyword_0());
		c.setLinewrap().after(block.getRightCurlyBracketKeyword_2());

		// Param
		Keyword fullStop = f.getQualifiedExpressionAccess().getFullStopKeyword_1_1();
		c.setNoLinewrap().around(fullStop);
		c.setNoSpace().around(fullStop);
		c.setNoSpace().after(f.getPropertyAccessAccess().getAlternatives_1());
		c.setNoSpace().after(f.getPropertyAccessAccess().getAlternatives_2());
		
		// Invocation
		c.setNoSpace().around(f.getInvocationAccess().getLeftParenthesisKeyword_1());
		c.setNoSpace().around(f.getInvocationAccess().getRightParenthesisKeyword_3());
		c.setNoSpace().before(f.getInvocationAccess().getCommaKeyword_2_1_0());
		
		// Array element access
		ArrayElementExpressionElements arrayElement = f.getArrayElementExpressionAccess();
		c.setNoSpace().around(arrayElement.getLeftSquareBracketKeyword_1_1_0());
		c.setNoSpace().around(arrayElement.getRightSquareBracketKeyword_1_1_2());
		
		//Arrays
		c.setNoSpace().after(f.getArrayAccess().getLeftSquareBracketKeyword_1());
		c.setNoSpace().before(f.getArrayAccess().getRightSquareBracketKeyword_3());
		c.setNoSpace().before(f.getArrayAccess().getCommaKeyword_2_1_0());
		
		// Unary expression
		c.setNoSpace().before(f.getUnaryExpressionAccess().getOpAssignment_0_1_1());
		c.setNoSpace().after(f.getUnaryExpressionAccess().getOpAssignment_1_0());
		
		// Parenthesis
		c.setNoSpace().after(f.getParExpressionAccess().getLeftParenthesisKeyword_0());
		c.setNoSpace().before(f.getParExpressionAccess().getRightParenthesisKeyword_2());
		
		// If
		IfStatementElements ifStmt = f.getIfStatementAccess();
		configureParenthesis(c, ifStmt.getLeftParenthesisKeyword_1(), 
				ifStmt.getRightParenthesisKeyword_3());
		
		// For
		ForStatementElements forStmt = f.getForStatementAccess();
		configureParenthesis(c, forStmt.getLeftParenthesisKeyword_1(), 
				forStmt.getRightParenthesisKeyword_7());
		c.setNoSpace().before(forStmt.getSemicolonKeyword_3());
		c.setNoSpace().before(forStmt.getSemicolonKeyword_5());
		
		// While
		WhileStatementElements whileStmt = f.getWhileStatementAccess();
		configureParenthesis(c, whileStmt.getLeftParenthesisKeyword_1(), 
			whileStmt.getRightParenthesisKeyword_3());
		
		// comments
		c.setNoLinewrap().before(f.getSL_COMMENTRule());
		
//		c.setNoSpace().before(f.getVariableDeclarationsAccess().getCommaKeyword_1_1());
		c.setNoLinewrap().after(f.getExpressionAccess().getOpAssignment_0_1_1());
		
		configureParenthesis(c, f.getVectorAccess().getLeftParenthesisKeyword_0(), 
				f.getVectorAccess().getRightParenthesisKeyword_3());
		c.setNoSpace().before(f.getVectorAccess().getCommaKeyword_2_0());
		
		c.setNoSpace().before(f.getWildcardExpressionAccess().getFullStopAsteriskKeyword_1());
	}

	private void configureParenthesis(FormattingConfig c, Keyword left,
			Keyword right) {
		c.setNoSpace().after(left);
		c.setNoSpace().before(right);
//		c.setLinewrap().after(right);
	}
}
